/**
 * @module node-zk-treecache
 */
/**  */
import { State } from "node-zookeeper-client";
import { ConnectionState } from "./ConnectionState";
import { CuratorFramework } from "./CuratorFramework";
export declare type ConnectionStateListener = (client: CuratorFramework, state: ConnectionState) => void;
export interface PartialZooKeeperClient {
    addListener(event: "state", cb: (state: State) => void): this;
    getState(): State;
}
/**
 * @private
 */
export declare class ConnectionStateManager {
    private zkClient;
    private numberOfConnectEvent;
    private listeners;
    constructor(zkClient: PartialZooKeeperClient, curator: CuratorFramework);
    addConnectionStateListener(listener: ConnectionStateListener): void;
    removeConnectionStateListener(listener: ConnectionStateListener): void;
    readonly connectionState: ConnectionState;
    readonly isConnected: boolean;
    private zkStateToCS(s);
}
