/**
 * @module node-zk-treecache
 */
/**  */
import { Client, Exception } from "node-zookeeper-client";
import { ConnectionStateListener } from "./ConnectionStateManager";
import { GetChildrenBuilder, GetDataBuilder, ExistsBuilder } from "./Builders";
export interface CuratorFramework {
    createContainers(path: string, cb: (err: Error | Exception, path: string) => void): void;
    addConnectionStateListener(listener: ConnectionStateListener): void;
    removeConnectionStateListener(listener: ConnectionStateListener): void;
    isConnected(): boolean;
    getChildren(): GetChildrenBuilder;
    getData(): GetDataBuilder;
    checkExists(): ExistsBuilder;
}
export declare function newCuratorFramework(zkClient: Client): CuratorFramework;
/**
 * @private
 */
export declare class CuratorFrameworkImpl implements CuratorFramework {
    zkClient: Client;
    private connectionStateManager;
    constructor(zkClient: Client);
    createContainers(path: string, cb: (err: Error | Exception, path: string) => void): void;
    addConnectionStateListener(listener: ConnectionStateListener): void;
    removeConnectionStateListener(listener: ConnectionStateListener): void;
    isConnected(): boolean;
    getChildren(): GetChildrenBuilder;
    getData(): GetDataBuilder;
    checkExists(): ExistsBuilder;
}
