/**
 * @module node-zk-treecache
 */
/**  */
import { Client } from "node-zookeeper-client";
import { TreeCacheSelector } from "./TreeCacheSelector";
import { TreeCache, Logger } from "./TreeCache";
export interface TreeCacheBuilder {
    build(): TreeCache;
}
export interface ConsoleLike {
    log(message?: any, ...optionalParams: any[]): void;
}
export declare const consoleLogger: (id: number, console: ConsoleLike) => {
    id: number;
    debug(msg: string, ...args: any[]): void;
    info(msg: string, ...args: any[]): void;
    warn(msg: string, ...args: any[]): void;
    error(msg: string, ...args: any[]): void;
};
export declare class TreeCacheBuilder {
    private client;
    private path;
    private cacheData;
    private maxDepth;
    private createParentNodes;
    private selector;
    private logger;
    constructor(client: Client, path: string);
    withLogger(logger: Logger): this;
    withCacheData(cacheData: boolean): this;
    withMaxDepth(maxDepth: number): this;
    withCreateParentNodes(createParentNodes: boolean): this;
    withSelector(selector: TreeCacheSelector): this;
}
